program dkkcheck(input,output);
{ verify e.g. that DK has norm < 4/5 }
const
  hdim=29;
  edim=59;
  vdim=200;
  lmax=29;
  rho_val='6.0E+0';

%include 'types.h';

var
  i,j: integer;
  rho,sn: scalar;
  w: ltuple;
  va,vf,vi: vector;
  dkk,g,ginv,mt1,mt2: matrix;

%include 'reps.i';
%include 'scalar.i';
%include 'vector.i';
%include 'linear.i';

begin { dkkcheck }
  sinit;
  ssset(rho_val,rho);
  mread('g.m',g);
  mread('ginv.m',ginv);
  mread('dkkt.m',mt1);
  vread('approx.v',rho,va);
  vread('fixpt.v',rho,vf);
  vread('kkball.v',rho,vi);
  writeln;

  for i:=0 to lmax do begin
    for j:=0 to lmax do dkk[i,j]:=mt1[j,i];
    w[i]:=sone;
  end;

  writeln('dkkcheck: computing norm of DK');
  mprod(dkk,g,mt1);
  mprod(ginv,mt1,mt2);
  mnorm(w,mt2,sn);

  writeln('dkkcheck: bound on norm =',rst(sn.u));
  ismult(5,sn);
  isdiv(4,sn);
  if slt(sn,sone) then writeln('dkkcheck: ok')
  else writeln('dkkcheck: error - norm not less than 4/5');

  writeln('dkkcheck: comparing coeffs 0..3 of fixpt.v and approx.v');
  write('dkkcheck:');
  for i:=0 to 3 do begin
    if ssub(vf[i],va[i]) then write(' ok') else write(' error');
  end;
  writeln;

  writeln('dkkcheck: checking that fixpt.v is contained in kkball.v');
  if vsub(vf,vi) then writeln('dkkcheck: ok')
  else writeln('dkkcheck: error - test failed');

  sdone('dkkcheck');
end { dkkcheck }.

