program kkiter(input,output);
{ iterate K to improve pcoeff.v poly.v }
const
  hdim=29;
  edim=59;
  lmax=3;
  vdim=200;
  rho_val='6.0E+0';
  iter=80;

%include 'types.h';

var
  normalize: boolean;
  i: integer;
  beta2,rho,cov,sigma,tau: scalar;
  st1,st2: scalar;
  u,umax,lnormal: ltuple;
  v1,v2,vt,vkappa: vector;

%include 'reps.i';
%include 'scalar.i';
%include 'vector.i';
%include 'linear.i';
%include 'kkmap.i';

begin { kkiter }
  sinit;
  ssset(rho_val,rho);
  sread('beta2.s',beta2);
  sread('cov.s',cov);
  writeln;

  vread('pcoeff.v',rho,v2);
  vread('poly.v',rho,vt);
  v2[vdim]:=vt[vdim];
  vread('approx.v',rho,vt);
  st1:=vt[0];
  shrink(st1);
  vsprod(st1,v2,v1);                     { approx fixed point }

  kkinit(vt,u);        { approx.v to be checked by dkkcheck.p }
  writeln;

  writeln('kkiter: initializing convolution');
  vconvinit(cov,rho,vkappa);
  vwrite('kkappa.v',vkappa);
  writeln;

  writeln('kkiter: improving approximate fixed point');
  normalize:=false;
  for i:=1 to iter do begin
    writeln('step',i:3);
    kk(v1,v2,u);
    writeln;
    vdiff(v1,v2,vt);
    vnorm(vt,rho,st1);
    rdiff(v2[0].u,v2[0].l,st2.u);
    writeln('v0-width =',rst(st2.u));
    writeln('diffnorm =',rst(st1.u));
    v1:=v2;
  end;
  vwrite('kkin.v',v1);                { improved approximation }
  writeln;

  writeln('kkiter: apply K to improved approximation ');
  normalize:=true;
  kk(v1,v2,u);
  vwrite('kkout.v',v2);
  writeln;

  sdone('kkiter');
end { kkiter }.

