program kkmore(input,output);
{ construct ball for the contraction K }
const
  hdim=29;
  edim=59;
  lmax=29;
  vdim=200;
  rho_val='6.0E+0';

%include 'types.h';

var
  i: integer;
  rho,st: scalar;
  w,lt1,lt2: ltuple;
  v1,v2,vt1,vt2: vector;
  g,ginv: matrix;

%include 'reps.i';
%include 'scalar.i';
%include 'vector.i';
%include 'linear.i';

begin { kkmore }
  sinit;
  ssset(rho_val,rho);
  mread('g.m',g);
  vread('kkin.v',rho,v1);
  vread('kkout.v',rho,v2);
  writeln;

  writeln('kkmore: inverting G');
  minverse(g,ginv);
  mwrite('ginv.m',ginv);
  writeln;

  writeln('kkmore: constructing ball for contraction K');
  for i:=0 to lmax do w[i]:=sone;           { weights for new norm }
  vdiff(v2,v1,vt1);
  vlconvert(rho,vt1,lt1);
  lmprod(ginv,lt1,lt2);
  lnorm(w,lt2,st);
  writeln('kkmore: diffnorm =',rst(st.u));

  ismult(5,st);      { radius of ball, to be checked by dkkcheck.p }
  lball(st,w,lt1);
  lmprod(g,lt1,lt2);
  lvconvert(rho,lt2,vt2);
  vsum(v1,vt2,vt1);
  vwrite('kkball.v',vt1);
  writeln;

  sdone('kkmore');
end { kkmore }.

