program mmrest(input,output);
{ second part of M: convolution and contraction step }
const
  hdim=93;
  edim=187;
  vdim=1001;
  lmax=29;

%include 'types.h';

var
  cov,rho,diffnorm: scalar;
  v1,v2,v3,vkappa: vector;
  m: matrix;

%include 'reps.i';
%include 'scalar.i';
%include 'vector.i';
%include 'linear.i';

begin { mmrest }
  sinit;

  writeln('mmrest: reading sqr.out.v and applying convolution');
  sread('rho.s',rho);
  sread('cov.s',cov);
  vread('sqr.out.v',rho,v3);
  vread('kappa.v',rho,vkappa);
  vpositive(vkappa);
  vconv(vdim,cov,vkappa,v3,v2);
  vwrite('conv.out.v',v2);
  writeln;

  writeln('mmrest: contraction step');
  vread('approx.v',rho,v1);
  vdiff(v2,v1,v3);
  mread('m.m',m);
  vmprod(m,v3,v2);
  vsum(v1,v2,v3);
  vwrite('difference.v',v2);
  vwrite('mm.out.v',v3);

  vnorm(v2,rho,diffnorm);
  swrite('diffnorm.s',diffnorm);
  writeln;

  sdone('mmrest');
end { mmrest }.
