program zcheck(input,output);
{ check that fixpt.v has zdim zeros near those in zeros.t }
const
  hdim=93;
  edim=187;
  vdim=1001;
  lmax=0;
  dz_val='1.0E-40';

%include 'types.h';

var
  ok: boolean;
  i,ysi: integer;
  dz,rho,x,y: scalar;
  va,vc,vf: vector;
  guess: zeros;

%include 'reps.i';
%include 'scalar.i';
%include 'vector.i';

%include 'ztread';

begin { zcheck }
  sinit;
  ssset(dz_val,dz);
  sread('rho.s',rho);
  ztread('zeros.t',guess);
  vread('approx.v',rho,va);
  vread('contracted.v',rho,vc);
  vsum(va,vc,vf);
  writeln;
  vwrite('fixpt.v',vf);
  writeln;

  writeln('zcheck: checking zeros');
  ysi:=1;  
  for i:=0 to zdim do begin
    write(i:4); flush(output);

    sdiff(guess[i],dz,x);
    sneg(x);
    sval(vf,rho,x,y);
    ok:=(y.l.si=ysi) and (y.u.si=ysi);
    ysi:=-ysi;

    ssum(guess[i],dz,x);
    sneg(x);
    sval(vf,rho,x,y);
    ok:=ok and (y.l.si=ysi) and (y.u.si=ysi);

    if not ok then write(' error ');
    if (i mod 10)=9 then writeln;
  end;
  writeln;

  sdone('zcheck');
end { zcheck }.

